<?php
/**
 * Copyright (©) 2020 Pinpoint Designs LTD. All right's reserved.
 *
 * Author: Chandravadana Kandregula
 * Website: http://www.pinpointdesigns.co.uk
 *
 * Class Toolbar
 * @package Pinpoint\SortByPrice\Plugin\Catalog\Block;
 */

namespace Pinpoint\SortByPrice\Plugin\Catalog\Block;
use Pinpoint\SortByPrice\Helper\Data;

class Toolbar
{
    /**
     * @param \Magento\Catalog\Block\Product\ProductList\Toolbar $subject
     * @param \Closure $proceed
     * @param $collection
     * @return mixed
     */
    public function aroundSetCollection(
        \Magento\Catalog\Block\Product\ProductList\Toolbar $subject,
        \Closure $proceed,
        $collection
    ) {
        $currentOrder = $subject->getCurrentOrder();
        $result = $proceed($collection);

        if ($currentOrder) {
            if ($currentOrder == Data::HIGH_TO_LOW) {
                $subject->getCollection()->setOrder(Data::PRICE, \Magento\Framework\Api\SortOrder::SORT_DESC);
            } elseif ($currentOrder == Data::LOW_TO_HIGH) {
                $subject->getCollection()->setOrder(Data::PRICE, \Magento\Framework\Api\SortOrder::SORT_ASC);
            }
        }
        return $result;
    }
}
